linux-xfs.vger.kernel.org archive mirror
 help / color / mirror / Atom feed
From: "Darrick J. Wong" <darrick.wong@oracle.com>
To: darrick.wong@oracle.com, guaneryu@gmail.com
Cc: linux-xfs@vger.kernel.org, fstests@vger.kernel.org
Subject: [PATCH 2/2] xfs: test the xfs_db ls command
Date: Tue, 27 Oct 2020 12:03:32 -0700	[thread overview]
Message-ID: <160382541257.1203622.11553283849694190202.stgit@magnolia> (raw)
In-Reply-To: <160382540004.1203622.14607732322524118731.stgit@magnolia>

From: Darrick J. Wong <darrick.wong@oracle.com>

Make sure that the xfs_db ls command works the way the author thinks it
does.

Signed-off-by: Darrick J. Wong <darrick.wong@oracle.com>
---
 tests/xfs/918     |   87 +++++++++++++++++++++++++++++++++++++++++++++++++++++
 tests/xfs/918.out |   23 ++++++++++++++
 tests/xfs/group   |    1 +
 3 files changed, 111 insertions(+)
 create mode 100755 tests/xfs/918
 create mode 100644 tests/xfs/918.out


diff --git a/tests/xfs/918 b/tests/xfs/918
new file mode 100755
index 00000000..759943ac
--- /dev/null
+++ b/tests/xfs/918
@@ -0,0 +1,87 @@
+#! /bin/bash
+# SPDX-License-Identifier: GPL-2.0-or-later
+# Copyright (c) 2020, Oracle and/or its affiliates.  All Rights Reserved.
+#
+# FS QA Test No. 918
+#
+# Make sure the xfs_db ls command works the way the author thinks it does.
+# This means that we can list the current directory, list an arbitrary path,
+# and we can't list things that aren't directories.
+#
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1    # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+	cd /
+	rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+
+# real QA test starts here
+_supported_fs xfs
+_require_xfs_db_command "path"
+_require_xfs_db_command "ls"
+_require_scratch
+
+echo "Format filesystem and populate"
+_scratch_mkfs > $seqres.full
+_scratch_mount >> $seqres.full
+
+$XFS_INFO_PROG $SCRATCH_MNT | grep -q ftype=1 || \
+	_notrun "filesystem does not support ftype"
+
+filter_ls() {
+	sed	-e "s/^$root_ino /rootd/g" \
+		-e "s/^$a_ino /a_ino/g" \
+		-e "s/^$b_ino /b_ino/g" \
+		-e "s/^$c_ino /c_ino/g" \
+		-e "s/^$d_ino /d_ino/g" \
+		-e "s/^$e_ino /e_ino/g" |
+	awk '{printf("%s %s %s %s %s\n", $1, $2, $3, $4, $5);}'
+}
+
+mkdir $SCRATCH_MNT/a
+mkdir $SCRATCH_MNT/a/b
+$XFS_IO_PROG -f -c 'pwrite 0 61' $SCRATCH_MNT/a/c >> $seqres.full
+ln $SCRATCH_MNT/a/c $SCRATCH_MNT/d
+ln -s -f b $SCRATCH_MNT/a/e
+
+root_ino=$(stat -c '%i' $SCRATCH_MNT)
+a_ino=$(stat -c '%i' $SCRATCH_MNT/a)
+b_ino=$(stat -c '%i' $SCRATCH_MNT/a/b)
+c_ino=$(stat -c '%i' $SCRATCH_MNT/a/c)
+d_ino=$(stat -c '%i' $SCRATCH_MNT/d)
+e_ino=$(stat -c '%i' $SCRATCH_MNT/a/e)
+
+_scratch_unmount
+
+echo "Manually navigate to root dir then list"
+_scratch_xfs_db -c 'sb 0' -c 'addr rootino' -c ls | filter_ls
+
+echo "Use path to navigate to root dir then list"
+_scratch_xfs_db -c 'path /' -c ls | filter_ls
+
+echo "Use path to navigate to /a then list"
+_scratch_xfs_db -c 'path /a' -c ls | filter_ls
+
+echo "Use path to navigate to /a/b then list"
+_scratch_xfs_db -c 'path /a/b' -c ls | filter_ls
+
+echo "Use path to navigate to /a/c then list"
+_scratch_xfs_db -c 'path /a/c' -c ls | \
+	sed -e "s/^$c_ino /c_ino /g" -e "s/<$c_ino>/<c_ino>/g" |
+	awk '{printf("%s %s %s\n", $1, $2, $5);}'
+
+# success, all done
+status=0
+exit
diff --git a/tests/xfs/918.out b/tests/xfs/918.out
new file mode 100644
index 00000000..2e0ad939
--- /dev/null
+++ b/tests/xfs/918.out
@@ -0,0 +1,23 @@
+QA output created by 918
+Format filesystem and populate
+Manually navigate to root dir then list
+rootd directory 0x0000002e 1 .
+rootd directory 0x0000172e 2 ..
+a_ino directory 0x00000061 1 a
+c_ino regular 0x00000064 1 d
+Use path to navigate to root dir then list
+rootd directory 0x0000002e 1 .
+rootd directory 0x0000172e 2 ..
+a_ino directory 0x00000061 1 a
+c_ino regular 0x00000064 1 d
+Use path to navigate to /a then list
+a_ino directory 0x0000002e 1 .
+rootd directory 0x0000172e 2 ..
+b_ino directory 0x00000062 1 b
+c_ino regular 0x00000063 1 c
+e_ino symlink 0x00000065 1 e
+Use path to navigate to /a/b then list
+b_ino directory 0x0000002e 1 .
+a_ino directory 0x0000172e 2 ..
+Use path to navigate to /a/c then list
+c_ino regular <c_ino>
diff --git a/tests/xfs/group b/tests/xfs/group
index 82e02196..4b0caea4 100644
--- a/tests/xfs/group
+++ b/tests/xfs/group
@@ -526,3 +526,4 @@
 763 auto quick rw realtime
 915 auto quick quota
 917 auto quick db
+918 auto quick db


  parent reply	other threads:[~2020-10-27 19:03 UTC|newest]

Thread overview: 7+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2020-10-27 19:03 [PATCH RFC 0/2] xfs_db: add minimal directory navigation Darrick J. Wong
2020-10-27 19:03 ` [PATCH 1/2] xfs: test the xfs_db path command Darrick J. Wong
2020-10-27 19:03 ` Darrick J. Wong [this message]
2020-10-29 20:24   ` [PATCH 2/2] xfs: test the xfs_db ls command Darrick J. Wong
2021-03-23  4:20 [PATCHSET 0/2] fstests: test xfs_db directory navigation Darrick J. Wong
2021-03-23  4:20 ` [PATCH 2/2] xfs: test the xfs_db ls command Darrick J. Wong
2021-03-25 10:08   ` Chandan Babu R
2021-03-25 16:35     ` Darrick J. Wong

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=160382541257.1203622.11553283849694190202.stgit@magnolia \
    --to=darrick.wong@oracle.com \
    --cc=fstests@vger.kernel.org \
    --cc=guaneryu@gmail.com \
    --cc=linux-xfs@vger.kernel.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for NNTP newsgroup(s).